﻿using Microsoft.Win32;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace SORTER
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        int[] array;
        string path;
        FileInfo file;
        Stopwatch linearTime;
        Stopwatch minMaxTime;
        Stopwatch bubleTime;
        Stopwatch shuttleTime;
        Stopwatch insertionTime;

        public MainWindow()
        {
            InitializeComponent();
        }


        bool writeFile(string pathCopy, int[] arraySorted)
        {
            using (StreamWriter sw = new StreamWriter(pathCopy, false))
            {
                for (int i = 0; i < arraySorted.Length; ++i)
                {
                    sw.Write(arraySorted[i] + " ");
                }
            }

            return true;
        }

        (int[], string) linearSelectionSort(bool? ordering)
        {
            int[] arraySorted = new int[array.Length];
            int[] arrayCopy = new int[array.Length];

            int max = int.MinValue;
            int min = int.MaxValue;
            int index = 0;

            for (int i = 0; i < arrayCopy.Length; ++i)
            {
                arrayCopy[i] = array[i];
            }

            string pathCopy = file.DirectoryName + @"\Линейная сортировка.txt";
            if (!File.Exists(pathCopy))
            {
                File.Copy(path, pathCopy);
            }

            linearTime = new Stopwatch();
            linearTime.Start();

            if (ordering == false)
            {
                while (arraySorted.Length < arrayCopy.Length)
                {
                    for (int i = 0; i < arrayCopy.Length; ++i)
                    {
                        if (max <= arrayCopy[i] && arrayCopy[i] != 100)
                        {
                            max = arrayCopy[i];
                            index = i;
                        }
                    }
                    arrayCopy[index] = 100;
                    arraySorted.Append(max);
                    max = int.MinValue;
                }
            }
            else
            {
                while (arraySorted.Length < arrayCopy.Length)
                {
                    for (int i = 0; i < arrayCopy.Length; ++i)
                    {
                        if (min >= arrayCopy[i] && arrayCopy[i] != 100)
                        {
                            min = arrayCopy[i];
                            index = i;
                        }
                    }
                    arrayCopy[index] = 100;
                    arraySorted.Append(min);
                    min = int.MaxValue;
                }  
            }

            linearTime.Stop();
            return (arraySorted, pathCopy);
        }


        void methodMinMax(bool? ordering)
        {

            int[] arrayCopy = new int[array.Length];

            for (int i = 0; i < arrayCopy.Length; ++i)
            {
                arrayCopy[i] = array[i];
            }

            minMaxTime = new Stopwatch();
            minMaxTime.Start();

            if(ordering == false)
            {
                for (int i = 0; i < arrayCopy.Length - 1; ++i)
                {
                    int max = i;

                    for (int j = i + 1; j < arrayCopy.Length; ++j)
                    {
                        if (arrayCopy[j].CompareTo(arrayCopy[max]) > 0)
                        {
                            max = j;
                        }
                    }

                    int temp = array[i];
                    arrayCopy[i] = array[max];
                    arrayCopy[max] = temp;
                }

            }
            else
            {
                for (int i = 0; i < arrayCopy.Length - 1; ++i)
                {
                    int max = i;

                    for (int j = i + 1; j < arrayCopy.Length; ++j)
                    {
                        if (arrayCopy[j].CompareTo(arrayCopy[max]) < 0)
                        {
                            max = j;
                        }
                    }

                    int temp = arrayCopy[i];
                    arrayCopy[i] = arrayCopy[max];
                    arrayCopy[max] = temp;
                }

            }

            minMaxTime.Stop();

            string pathCopy = file.DirectoryName + @"\МинМакс.txt";
            if(!File.Exists(pathCopy))
            {
                File.Copy(path, pathCopy);
            }

            writeFile(pathCopy, arrayCopy);
        }


        void BubbleSort(bool? ordering)
        {

            int[] arrayCopy = new int[array.Length];

            for (int i = 0; i < arrayCopy.Length; ++i)
            {
                arrayCopy[i] = array[i];
            }

            int temp;

            bubleTime = new Stopwatch();
            bubleTime.Start();

            if (ordering == false)
            {
                for (int i = 0; i < arrayCopy.Length - 1; i++)
                {
                    for (int j = 0; j < arrayCopy.Length - i - 1; j++)
                    {
                        if (arrayCopy[j + 1] > arrayCopy[j])
                        {
                            temp = arrayCopy[j + 1];
                            arrayCopy[j + 1] = arrayCopy[j];
                            arrayCopy[j] = temp;
                        }
                    }
                }
            }
            else
            {
                for (int i = 0; i < arrayCopy.Length - 1; i++)
                {
                    for (int j = 0; j < arrayCopy.Length - i - 1; j++)
                    {
                        if (arrayCopy[j + 1] < arrayCopy[j])
                        {
                            temp = arrayCopy[j + 1];
                            arrayCopy[j + 1] = arrayCopy[j];
                            arrayCopy[j] = temp;
                        }
                    }
                }
            }

            bubleTime.Stop();

            string pathCopy = file.DirectoryName + @"\Пузырьковая сортировка.txt";
            if (!File.Exists(pathCopy))
            {
                File.Copy(path, pathCopy);
            }

            writeFile(pathCopy, arrayCopy);
        }


        void ShuttleSort(bool? ordering)
        {

            int[] arrayCopy = new int[array.Length];

            for (int i = 0; i < arrayCopy.Length; ++i)
            {
                arrayCopy[i] = array[i];
            }

            int temp;

            shuttleTime = new Stopwatch();
            shuttleTime.Start();

            if(ordering == false)
            {
                for (int i = 1; i < arrayCopy.Length; i++)
                {
                    if (arrayCopy[i] > arrayCopy[i - 1])
                    {
                        temp = arrayCopy[i];
                        arrayCopy[i] = arrayCopy[i - 1];
                        arrayCopy[i - 1] = temp;
                        for (int j = i - 1; (j - 1) >= 0; j--)
                        {
                            if (arrayCopy[j] > arrayCopy[j - 1])
                            {
                                temp = arrayCopy[j];
                                arrayCopy[j] = arrayCopy[j - 1];
                                arrayCopy[j - 1] = temp;
                            }
                            else
                            {
                                break;
                            }
                        }
                    }
                }
            }
            else
            {
                for (int i = 1; i < arrayCopy.Length; i++)
                {
                    if (arrayCopy[i] < arrayCopy[i - 1])
                    {
                        temp = arrayCopy[i];
                        arrayCopy[i] = arrayCopy[i - 1];
                        arrayCopy[i - 1] = temp;
                        for (int j = i - 1; (j - 1) >= 0; j--)
                        {
                            if (arrayCopy[j] < arrayCopy[j - 1])
                            {
                                temp = arrayCopy[j];
                                arrayCopy[j] = arrayCopy[j - 1];
                                arrayCopy[j - 1] = temp;
                            }
                            else
                            {
                                break;
                            }
                        }
                    }
                }
            }

            shuttleTime.Stop();

            string pathCopy = file.DirectoryName + @"\Челночная сортировка.txt";
            if (!File.Exists(pathCopy))
            {
                File.Copy(path, pathCopy);
            }

            writeFile(pathCopy, arrayCopy);
        }


        void InsertionSort(bool? ordering)
        {

            int[] arrayCopy = new int[array.Length];

            for (int i = 0; i < arrayCopy.Length; ++i)
            {
                arrayCopy[i] = array[i];
            }

            int index, temp;

            insertionTime = new Stopwatch();
            insertionTime.Start();

            if (ordering == false)
            {
                for (int i = 0; i < arrayCopy.Length; ++i)
                {
                    index = i;
                    temp = arrayCopy[i];
                    for (int j = i + 1; j < arrayCopy.Length; ++j)
                    {
                        if (arrayCopy[j] > temp)
                        {
                            index = j;
                            temp = arrayCopy[j];
                        }
                    }
                    arrayCopy[index] = arrayCopy[i];
                    arrayCopy[i] = temp;
                }
            }
            else
            {
                for (int i = 0; i < arrayCopy.Length; ++i)
                {
                    index = i;
                    temp = arrayCopy[i];
                    for (int j = i + 1; j < arrayCopy.Length; ++j)
                    {
                        if (arrayCopy[j] < temp)
                        {
                            index = j;
                            temp = arrayCopy[j];
                        }
                    }
                    arrayCopy[index] = arrayCopy[i];
                    arrayCopy[i] = temp;
                }
            }

            insertionTime.Stop();

            string pathCopy = file.DirectoryName + @"\Сортировка вставки.txt";
            if (!File.Exists(pathCopy))
            {
                File.Copy(path, pathCopy);
            }

            writeFile(pathCopy, arrayCopy);
        }

        private void SortButton_Click(object sender, RoutedEventArgs e)
        {
            if(string.IsNullOrEmpty(path))
            {
                MessageBox.Show("Для сортировки нужно выбрать файл");
            }
            else
            {
                if (LinearButton.IsChecked == true)
                {
                    (int[] array, string pathCopy) = linearSelectionSort(Ascending.IsChecked);
                    writeFile(pathCopy, array);
                }
                else if (minMaxButton.IsChecked == true)
                {
                    methodMinMax(Ascending.IsChecked);
                }
                else if (BubbleButton.IsChecked == true)
                {
                    BubbleSort(Ascending.IsChecked);
                }
                else if (ShuttleButton.IsChecked == true)
                {
                    ShuttleSort(Ascending.IsChecked);
                }
                else if (InsertionButton.IsChecked == true)
                {
                    InsertionSort(Ascending.IsChecked);
                }

                MessageBox.Show("Массив отсортирован, файл с ним находится рядом с выбранным файлом");
            }
        }

        private void SelectFile_Click(object sender, RoutedEventArgs e)
        {
            OpenFileDialog OPF = new OpenFileDialog();
            OPF.Filter = "Файлы txt|*.txt";
            if (OPF.ShowDialog() == true)
            {
                path = OPF.FileName;
                file = new FileInfo(path);

                using (StreamReader sr = new StreamReader(OPF.FileName))
                {
                    try
                    {
                        string str = sr.ReadToEnd().Trim();
                        str = str.Replace("\n", " ");
                        str = str.Replace(",", "");
                        string[] arrayStr = str.Split(" ");

                        array = new int[arrayStr.Length];

                        for (int i = 0; i < arrayStr.Length; ++i)
                        {
                            array[i] = Convert.ToInt32(arrayStr[i]);
                        }
                    }
                    catch
                    {
                        MessageBox.Show("Файл пустой или данные не корректны");
                    }
                }
            }
        }

        private void Diagram_Click(object sender, RoutedEventArgs e)
        {
            if (linearTime == null || minMaxTime == null || bubleTime == null || shuttleTime == null || insertionTime == null)
            {
                MessageBox.Show("Для того, чтобы построить диаграмму, нужно отсортировать массив всеми способами");
            }
            else
            {
                Diagram wnd = new Diagram(linearTime.ElapsedTicks, minMaxTime.ElapsedTicks, bubleTime.ElapsedTicks, shuttleTime.ElapsedTicks, insertionTime.ElapsedTicks);
                wnd.Show();
            }
        }
    }
}
